Draft Dimension

From FreeCAD Documentation
Revision as of 16:41, 8 November 2018 by Vocx (talk | contribs) ({{Draft Tools navi}} and {{Userdocnavi}})

Draft Dimension

Menu location
Draft → Dimension
Workbenches
Draft, Arch
Default shortcut
D I
Introduced in version
-
See also
FlipDimension

Description

The dimension tool creates a dimension in the current document with two points defining the distance to measure, and a third point specifying where the dimension line passes.

How to use

  1. Press the Draft Dimension button, or press D then I keys.
  2. Click a point on the 3D view, or type a coordinate.
  3. Click a second point on the 3D view, or type a coordinate; the first two points define the measured distance.
  4. Click a third on the 3D view, or type a coordinate; the final point defines the position of the measurement line.

The measuring points can be changed after creation by changing the start and end properties.

The position of the measurement line can also be changed after creation by changing its direction property.

Available dimension types

Release the modifier (Alt or Shift) after picking a point or an edge.

  • Linear dimensions: hold the Alt key, or click on the select edge button, and pick a straight edge, then pick a second point to draw the dimension line parallel to that edge.
Note: you can also pre-select the edge before calling the tool.
  • Horizontal and vertical dimensions: pick one point, then pick a second point, then hold the Shift key and move the pointer horizontally or vertically, then pick a third point to draw the dimension line parallel to either the X axis or the Y axis.
Note 1: click and hold Shift and move the pointer in different directions many times until the dimension line aligns to the desired axis. Clicking Shift while the pointer is far from the first point will usually align the dimension to the X axis; if the pointer is close to the first point it will usually align the dimension to the Y axis.
Note 2: instead of picking two points, pick an edge while holding Alt.
  • Diameter dimensions: hold the Alt key and pick a curved edge, then pick a second point to draw the dimension line.
    • Radius dimensions: hold the Alt key and pick a curved edge, then hold the Shift key and pick a second point to draw the dimension line.
  • Angular dimensions: hold the Alt key and then pick two straight edges, then pick a point between the two edges to show the acute angle, or elsewhere to show the supplementary angle.

Note: by pre-selecting an edge, or by picking it with Alt or select edge, the dimension will become parametric, that is, it will remember which edge it is bound to. If the endpoints of that edge move later on, the dimension will follow them, and adjust the displayed measurement.

Options

  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the previous one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the Dimension tool will restart after you give the final point, allowing you to draw another dimension without pressing the tool button again; the following dimensions will start from the final point of the previous dimension, and will share the same baseline.
  • Press Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press Shift while drawing to constrain your next point horizontally or vertically in relation to the previous one, and to switch between diameter and radius modes.
  • Press Esc or the Close button to abort the current command, and finish continued dimensions; dimensions already placed will remain.

Properties

Data

  • DataStart: specifies the start point of the distance to measure.
  • DataEnd: specified the end point of the distance to measure.
  • DataDimline: specifies a point through which the dimension line must pass.
  • DataDistance: (read-only) indicates the measured length.
  • DataDiameter: if it is true it displays a diameter dimension; otherwise it displays a radius dimension; this property only works if the dimension is attached to a circular arc.

View

  • ViewExt Lines: specifies the maximum length of the extension lines that go from the measurement points to the dimension line.
  • ViewExt Overshoot: specifies the additional length of the extension lines beyond the dimension line.
  • ViewDim Overshoot: specifies the additional length added to the dimension line.
  • ViewArrow Size: specifies the size of the symbol displayed at the ends of the dimension line.
  • ViewArrow Type: specifies the type of symbol displayed at the ends of the dimension line, which can be dot, circle, arrow, or tick.
  • ViewFlip Arrows: specifies whether to flip the orientation of the symbols at the ends of the dimension line; it only works if these symbols are arrows.
  • ViewFont Name: specifies the font to use to draw the text. It can be a font name, such as "Arial", a default style such as "sans", "serif" or "mono", a family such as "Arial,Helvetica,sans" or a name with a style such as "Arial:Bold". If the given font is not found on the system, a generic one is used instead.
  • ViewFont Size: specifies the size of the letters.
  • ViewFlip Text: specifies whether to flip the orientation of the text indicating the measurement.
  • ViewText Position: specifies the position of the text in absolute coordinates, referred to the origin (0,0,0); leave this property at its default value (0,0,0) to display the text next to the dimension line.
  • ViewText Spacing: specifies the space between the text and the dimension line.
  • ViewOverride: specifies a custom text to display instead of the actual measurement. Use the string $dim inside the text to display the measurement value.
  • ViewDecimals: specifies the number of decimal places to display on the measurement.
  • ViewShow Unit: if it is true the unit is displayed next to numerical value of the measurement.
  • ViewUnit Override: specifies a unit in which to express the measurement, for example, "km", "m", "cm", "mm", "mi", "ft", "in"; leave this property blank to use the default units introduced in version 0.17

Scripting

See also: FreeCAD Scripting Basics, Draft API, and the autogenerated API documentation.

The Dimension tool can be used in macros and from the Python console by using the following function:

Dimension = makeDimension(p1, p2, p3=None, p4=None)

There are various ways to invoke this function, depending on the arguments passed to it:

Dimension = makeDimension(p1, p2, p3=None)
Dimension = makeDimension(object, i1, i2, p4=None)
Dimension = makeDimension(object, i1, mode, p4=None)
  • Creates a linear Dimension by measuring the distance between points p1 and p2.
  • Creates a linear Dimension linked to object, measuring the distance between its vertices indexed i1 and i2.
  • Creates a circular Dimension linked to object, with i1 being the index of the curved edge to measure, and mode being either "radius" or "diameter" to specify the type of dimension.
    • p3 in the first call, and p4 in the other two, specify an optional point through which the dimension line should go.
    • All points are defined by their FreeCAD.Vector.

To create an angular dimension use the following function:

Dimension = makeAngularDimension(center, angles, p3, normal=None)
Dimension = makeAngularDimension(center, [angle1, angle2], p3, normal=None)
  • Creates an angular Dimension from the given center point, the angles list with two elements, and the point {incode|p3}} through which the arc should go.
    • If angle1 > angle2, the displayed angle is the difference angle1 - angle2; otherwise, the explementary angle is displayed, 360 - (angle1 - angle2).
    • The angles should be given in radians; the math.radians() function can be used to convert angles given in degrees.

Example:

import math, FreeCAD, Draft

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(1000, 1000, 0)
p3 = FreeCAD.Vector(-2500, 0, 0)
Dimension1 = Draft.makeDimension(p1, p2, p3)

Polygon = Draft.makePolygon(3, radius=1000)
p4 = FreeCAD.Vector(-2000, 1500, 0)
Dimension2 = Draft.makeDimension(Polygon, 1, 2, p4)

center = FreeCAD.Vector(2000, 0, 0)
p5 = FreeCAD.Vector(3000, 1000, 0)
angle1 = math.radians(45)
angle2 = math.radians(10)
Dimension3 = Draft.makeAngularDimension(center, [angle1, angle2], p5)

Links